unit TUtility;
{$I ..\PDXRBLD.INC}

interface

uses DbiTypes;

{ TUtility (TUVerifyTable) Session Options }
const
  TU_Append_Errors = 1;
  TU_No_Secondary  = 2;
  TU_No_Warnings   = 4;
  TU_Header_Only   = 8;
  TU_Dialog_Hide   = 16;
  TU_No_Lock       = 32;

  UTILITYDLL = 'TUTILITY'; { Moved from implementation by RKS }

{ TUtility type definitions }
type
  hTUses  = word;
  phTUses = ^hTUses;
  { Verify Callback processes }
  TUVerifyProcess = (TUVerifyHeader, TUVerifyIndex, TUVerifyData, TUVerifySXHeader,
                     TUVerifySXIndex, TUVerifySXData, TUVerifySXIntegrity,
                     TUVerifyTableName);
  { Call back info for Verify Callback function }
  TUVerifyCallBack = {packed} record
    PercentDone: word;
    TableName: DBIPath;
    Process: TUVerifyProcess;
    CurrentIndex: word;
    TotalIndex: word;
  end;

{ TUtility functions }
function TUInit(hTUSession: phTUses): DBIResult;
function TUVerifyTable(hTUSession: hTUses; 
                       pszTableName, 
                       pszDriverType,
                       pszErrTableName, 
                       pszPassword: PChar; 
                       iOptions: integer;
                   var piErrorLevel: word): DBIResult;
function TURebuildTable(hTUSession: hTUses; 
                        pszTableName, 
                        pszDriverType,
                        pszBackupTableName, 
                        pszKeyviolName, 
                        pszProblemTableName: PChar; 
                        pCrDesc: pCRTblDesc): DBIResult;
function TUGetCRTblDescCount(hTUSession: hTUses; 
                             pszTableName: PChar; 
                         var iFldCount,iIdxCount, iSecRecCount, iValChkCount,
                             iRintCount, iOptParams, iOptDataLen: word):
                             DBIResult;
function TUFillCRTblDesc(hTUSession: hTUses; pCrDesc: pCRTblDesc;
                         pszTableName, pszPassword: PChar): DBIResult;
function TUFillCURProps(hTUSession: hTUses; pszTableName: PChar; tblProps:
                        pCURProps): DBIResult;
function TUExit(hTUSession: hTUses): DBIResult;
function TUGetErrorString(iErrorcode: DBIResult; pszError: PChar): DBIResult;

implementation

{ Import by index changed to import by name by RK }
function TUInit;              external UTILITYDLL name 'TUINIT'; {index 2;}
function TUVerifyTable;       external UTILITYDLL name 'TUVERIFYTABLE'; {index 3;}
function TURebuildTable;      external UTILITYDLL name 'TUREBUILDTABLE'; {index 4;}
function TUGetCRTblDescCount; external UTILITYDLL name 'TUGETCRTBLDESCCOUNT'; {index 5;}
function TUFillCRTblDesc;     external UTILITYDLL name 'TUFILLCRTBLDESC'; {index 6;}
function TUFillCURProps;      external UTILITYDLL name 'TUFILLCURPROPS'; {index 7;}
function TUExit;              external UTILITYDLL name 'TUEXIT'; {index 8;}
function TUGetErrorString;    external UTILITYDLL name 'TUGETERRORSTRING'; {index 9;}

end.
