unit px3pImp;
{=================================================================
 Px3PImp - Paradox Process Password Protection import unit
==================================================================}

interface
uses
   Windows,BDE;


Const
  {Error codes returned by px3pProtect}
  px3pErr_None               = 0;   // OK
  px3pErr_CannotLoadIdapi    = 1;   // BDE not installed or interface ver. mismatch
  px3pErr_NoCryptInfo        = 2;   // No PETGV to alter
  px3pErr_CannotProtect      = 3;   // PETGV cannot be altered
  px3pErr_CannotEnumModules  = 4;   // Enumeration of the modules failed
  px3pErr_CannotGetOSVersion = 5;   // Failed in GetVersionEx
  px3pErr_NT4Required        = 6;   // Is WinNT < 4.0
  px3pErr_UnsupportedOS      = 7;   // Running in unknown OS


Type
  t_px3pProtect          = Function(px3pkey: pChar): integer;   stdcall;
  t_px3pIsTableProtected = Function (Dbsename,Tblname,Px3pkey,MastPswd: pChar;
                              VAR Rslt: wordBool): dbiResult;  stdcall;
  t_px3pLicPassword      = Procedure(LicPswd: pChar); stdcall;

VAR
  px3pProtect: t_px3pProtect = nil;
  px3pIsTableProtected : t_px3pIsTableProtected = nil;
  px3pLicPassword : t_px3pLicPassword = nil;

Function LoadPx3P: boolean;
procedure UNLoadPx3P;

implementation
const
  dllname='px3p.dll';

Var
  DLLHandle: Integer;

procedure UNLoadPx3P;
begin
  if DLLHandle <> 0 then begin
    px3pProtect  := nil;
    px3pIsTableProtected := nil;
    px3pLicPassword  := nil;
    FreeLibrary(DLLHandle);
    DLLHandle := 0;
  end;
end;

Function LoadPx3P: boolean;
begin
  if DLLHandle = 0 then begin
    DLLHandle := LoadLibrary(dllname);
    if DLLHandle <> 0 then begin
      px3pProtect  := GetprocAddress(DLLHandle, lpcstr(longint(1)));
      px3pIsTableProtected := GetprocAddress(DLLHandle, lpcstr(longint(2)));
      px3pLicPassword  := GetprocAddress(DLLHandle, lpcstr(longint(3)));
      if not assigned(px3pProtect) and
             assigned(px3pIsTableProtected) and
             assigned(px3pLicPassword) then begin
         UNLoadPx3P;
      end;
    end;
  end;
  Result := DLLHandle <> 0;
end;


end.
