{=====================================================================
 Pdxrbld - Paradox tables repair utility  Copyright 1998 by
 Roman Krejci-RKS, Pujmanove 1552, 140 00 Prague 4, Czech Republic
 http://www.rksolution.cz, EMail INFO@rksolution.cz
 =====================================================================}

unit Pswd;
{$I PDXRBLD.INC}

interface

uses
  {$IFDEF WIN32}
  Windows,
  {$ELSE}
  Wintypes, WinProcs,
  {$ENDIF}
  Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls,
  LowStuff,
  Translat;

type
  TFormPswd = class(TForm)
    Edit1: TEdit;
    Button1: TButton;
    Button2: TButton;
    Label1: TLabel;
    Button3: TButton;
    procedure FormCloseQuery(Sender: TObject; var CanClose: Boolean);
    procedure FormCreate(Sender: TObject);
  private
    { Private declarations }
{$IFDEF WIN32}
    Px3PKeySearchList : tStringList;
    Px3PKeyFound  : String;
{$ENDIF}
    CheckSumToTest: longint;
    procedure SetTexts;
  public
    { Public declarations }
  end;

Function MyGetpassword(const tblname: string;
{$IFDEF WIN32}
                       Px3PKeysList : tStringList;
                       var   Px3PKey: string;
{$ENDIF}
                       var   apswd: string;
                       Const _CheckSumToTest: longint): boolean;

Function CalcPswCheckSum(Const aPsw: string): longint;
{ Calculates password checksum }

implementation

{$R *.DFM}

Function MyGetpassword(const tblname: string;
{$IFDEF WIN32}
                       Px3PKeysList : tStringList;
                       var   Px3PKey: string;
{$ENDIF}
                       var   apswd: string;
                       Const _CheckSumToTest: longint): boolean;
Var OldCursor: hCursor;
begin
  result := false;
  OldCursor := Screen.Cursor;
  Screen.Cursor := crDefault;
  with TFormPswd.Create(NIL) do TRY
    label1.caption := format(LoadStr(msg_Tableispasswordprotected),[tblname]);
    CheckSumToTest := _CheckSumToTest;
{$IFDEF WIN32}
    Px3PKeySearchList := Px3PKeysList;
{$ENDIF}
    case Showmodal of
    mrOK : begin
{$IFDEF WIN32}
        Px3PKey := Px3PKeyFound;
{$ENDIF}
        apswd   := edit1.text;
        result  := true;
      end;
    mrAbort: sysutils.abort;
    end;
  Finally
    Screen.Cursor := OldCursor;
    Free;
  End;
end;

{----------------------------------------------------------------------}
{ Algorithm for calculating master password checksum in Paradox tables }
{----------------------------------------------------------------------}

type
  tCodeBuff = array [0..255] of byte;
{$IFDEF WIN32}
Var
{$ELSE}
Const
{$ENDIF}
  codetabD: array [0..255] of byte = (
$B2,$A5,$0C,$DD,$38,$FE,$CB,$5B,$0C,$23,$EC,$6A,$95,$3E,$D5,$2D,
$2C,$F7,$2D,$30,$EA,$15,$98,$B4,$5F,$82,$D3,$AF,$F4,$4C,$84,$16,
$74,$17,$05,$11,$AC,$DB,$43,$91,$9C,$77,$A0,$38,$BE,$D6,$8F,$25,
$B1,$EE,$6D,$80,$37,$14,$A9,$7A,$57,$38,$6C,$2F,$A6,$4F,$7C,$38,
$71,$D4,$0B,$51,$F6,$B9,$45,$21,$1D,$6C,$4D,$87,$6E,$A7,$E7,$21,
$0D,$85,$F4,$CE,$3A,$81,$6A,$3E,$D7,$32,$A4,$23,$AC,$E9,$01,$91,
$B0,$ED,$C7,$46,$12,$AC,$15,$3D,$FF,$1B,$7B,$3B,$BA,$EE,$2C,$2C,
$68,$A6,$62,$60,$ED,$5B,$84,$33,$61,$62,$39,$79,$D4,$D2,$EB,$60,
$B8,$25,$1D,$DB,$FF,$3A,$21,$9A,$B0,$C3,$F7,$63,$52,$F5,$22,$94,
$F9,$B4,$B7,$BE,$9F,$54,$3B,$CE,$E1,$3C,$73,$CB,$EA,$2D,$45,$00,
$9D,$C2,$78,$E7,$96,$0F,$14,$3A,$A4,$DC,$01,$64,$8D,$D6,$59,$4E,
$39,$0F,$15,$7D,$F0,$8C,$8A,$C5,$78,$03,$4A,$E8,$FB,$EF,$18,$B4,
$52,$31,$79,$D0,$8E,$AA,$C3,$C6,$CE,$ED,$E9,$42,$5A,$D6,$2D,$06,
$C7,$9A,$B1,$38,$62,$D9,$7E,$61,$74,$D2,$46,$DE,$CB,$2B,$0C,$59,
$0B,$64,$9D,$1C,$4F,$B2,$06,$91,$9B,$63,$B5,$B2,$A9,$FD,$AD,$5A,
$38,$F9,$13,$6E,$9D,$2D,$4B,$02,$F9,$13,$6F,$50,$CB,$21,$09,$FA);

  codetabE: array [0..255] of byte = (
$61,$A7,$79,$02,$37,$34,$6F,$81,$01,$C2,$B2,$B3,$D6,$4D,$3E,$03,
$06,$60,$98,$44,$46,$68,$1C,$EB,$10,$4A,$5B,$AE,$22,$48,$24,$42,
$9F,$55,$90,$C1,$7D,$2F,$6C,$41,$4E,$82,$56,$D8,$1E,$32,$28,$C6,
$ED,$BC,$3C,$3A,$E9,$87,$3B,$8F,$86,$08,$A3,$FB,$A4,$62,$99,$FF,
$59,$B9,$DE,$2D,$58,$93,$1B,$B1,$76,$2B,$AA,$D9,$2A,$AC,$CA,$F9,
$E0,$B7,$05,$11,$77,$A9,$8E,$EF,$B5,$BB,$26,$EA,$8D,$18,$9B,$FE,
$C7,$F8,$5A,$83,$FD,$2E,$6B,$84,$33,$FA,$69,$D4,$74,$BF,$CB,$C4,
$19,$96,$3F,$E5,$25,$F2,$A5,$D5,$95,$F3,$A0,$39,$DC,$E4,$A1,$7F,
$7B,$49,$7A,$F1,$EE,$F7,$75,$09,$91,$67,$97,$38,$D3,$89,$47,$31,
$1F,$2C,$0E,$CE,$20,$CC,$9C,$23,$17,$92,$0F,$F4,$13,$64,$71,$C8,
$CD,$3D,$B4,$CF,$E1,$50,$52,$AF,$6D,$27,$B6,$94,$30,$04,$8C,$53,
$4B,$D2,$4F,$21,$29,$6A,$1A,$EC,$5C,$7E,$51,$9A,$0D,$85,$E6,$1D,
$C5,$88,$A8,$DD,$9E,$F6,$5F,$DA,$BD,$6E,$9D,$54,$DB,$5E,$C0,$80,
$5D,$B8,$40,$63,$15,$12,$A2,$0C,$07,$AD,$70,$14,$72,$16,$D0,$A6,
$65,$35,$BA,$E7,$AB,$FC,$C3,$C9,$BE,$0B,$B0,$F5,$45,$E2,$4C,$73,
$0A,$36,$78,$43,$8B,$8A,$F0,$66,$D1,$00,$DF,$7C,$E3,$E8,$57,$D7);

  codetabF: array [0..255] of byte = (
$F9,$08,$03,$0F,$AD,$52,$10,$D8,$39,$87,$F0,$E9,$D7,$BC,$92,$9A,
$18,$53,$D5,$9C,$DB,$D4,$DD,$98,$5D,$70,$B6,$46,$16,$BF,$2C,$90,
$94,$B3,$1C,$97,$1E,$74,$5A,$A9,$2E,$B4,$4C,$49,$91,$43,$65,$25,
$AC,$8F,$2D,$68,$05,$E1,$F1,$04,$8B,$7B,$33,$36,$32,$A1,$0E,$72,
$D2,$27,$1F,$F3,$13,$EC,$14,$8E,$1D,$81,$19,$B0,$EE,$0D,$28,$B2,
$A5,$BA,$A6,$AF,$CB,$21,$2A,$FE,$44,$40,$62,$1A,$B8,$D0,$CD,$C6,
$11,$00,$3D,$D3,$9D,$E0,$F7,$89,$15,$6A,$B5,$66,$26,$A8,$C9,$06,
$DA,$9E,$DC,$EF,$6C,$86,$48,$54,$F2,$02,$82,$80,$FB,$24,$B9,$7F,
$CF,$07,$29,$63,$67,$BD,$38,$35,$C1,$8D,$F5,$F4,$AE,$5C,$56,$37,
$22,$88,$99,$45,$AB,$78,$71,$8A,$12,$3E,$BB,$5E,$96,$CA,$C4,$20,
$7A,$7E,$D6,$3A,$3C,$76,$DF,$01,$C2,$55,$4A,$E4,$4D,$D9,$1B,$A7,
$EA,$47,$0A,$0B,$A2,$58,$AA,$51,$D1,$41,$E2,$59,$31,$C8,$E8,$6D,
$CE,$23,$09,$E6,$6F,$C0,$2F,$60,$9F,$E7,$4E,$6E,$95,$A0,$93,$A3,
$DE,$F8,$B1,$8C,$6B,$77,$0C,$FF,$2B,$4B,$C7,$CC,$7C,$C3,$42,$FA,
$50,$A4,$ED,$FC,$7D,$73,$BE,$E3,$FD,$34,$5B,$17,$B7,$30,$84,$57,
$F6,$83,$75,$79,$9B,$EB,$C5,$85,$61,$4F,$69,$3B,$E5,$64,$5F,$3F);


Procedure CodeBufferA(Var buff:tCodeBuff; a,b,c,d: byte);
var
  buff2: tCodeBuff;
  i  : integer;
  x,y: byte;
begin
  for i := 0 to 255 do begin
    x := codetabE[(i + d) and $000000ff];
    y := buff[x] xor codetabD[(x + a) and $000000ff];
    y := y xor codetabE[(i + b) and $000000ff];
    y := y xor codetabF[(i + c) and $000000ff];
    buff2[i] := y;
  end;
  move(buff2,buff,SizeOf(tCodeBuff));
end;

Procedure CodeBufferB(Var buff:tCodeBuff; lenpassw: byte);
var
  i,x,y: byte;
begin
  for i := lenpassw to 255 do begin
    x := buff[i-lenpassw];
    y := codetabD[x] xor i;
    buff[i] := y;
  end
end;

Function makeLongFromBuff(partial: longint; const buff:tCodeBuff): longint;
var
  i,x,y,z : longint;
begin
  i := 0;
  y := 0;
  z := 0;
  while i <= 255 do begin
    x := buff[i];
    y := y xor x;
    inc(i);
    x := buff[i];
    z := z xor x;
    inc(i);
  end;
  result := (z shl 8) or y;
  if Result = 0 then Result := 1;
  Result := (Result shl 16) or partial;
end;


Function CalcPswCheckSum(Const aPsw: string): longint;
var
  buff: tCodeBuff;
  len,count,partial,x,y: longint;
begin
  if aPsw = '' then result := 0 else begin
    len := length(aPsw);
{concatenate password into buff}
    count := 256;
    while count >= len do begin
      move(aPsw[1],buff[256-count],len);
      dec(count,len);
    end;
    if count > 0 then move(aPsw[1],buff[256-count],count);
{1st buffer coding}
    CodeBufferA(buff,buff[0],buff[1],buff[2],buff[3]);
{calculate partial checksum}
    x := buff[0];
    y := buff[1];
    partial := (y shl 8) + x;
{copy password to buff once }
    move(aPsw[1],buff,len);
{2nd buffer coding}
    CodeBufferB(buff,len);
{3rd buffer coding}
    CodeBufferA(buff,buff[0],buff[20],buff[40],buff[255]);
{Retrieving result}
    result := makeLongFromBuff(partial, buff);
  end;
end;



{ tFormPswd }

procedure TFormPswd.SetTexts;
begin
  Caption := LoadStr(dfm_FormPswdCaption);
  Button1.Caption := LoadStr(dfm_FormPswdButton1Caption);
  Button2.Caption := LoadStr(dfm_FormPswdButton2Caption);
  Button3.Caption := LoadStr(dfm_FormPswdButton3Caption);
  edit1.text := '';
end;

procedure TFormPswd.FormCloseQuery(Sender: TObject; var CanClose: Boolean);
{$IFDEF WIN32}
Var i: Integer;
    Found: boolean;
    MyPx3PProtectCalled: boolean;
    Px3PKey: string;
{$ENDIF}
begin
 if modalresult=mrOK then begin
   if edit1.text='' then begin
     canclose := false;
   end else begin
{$IFDEF WIN32}
     Found := false;
     MyPx3PProtectCalled := false;
     Try
       For i := 0 to Px3PKeySearchList.Count - 1 do begin
         Px3PKey := Px3PKeySearchList[i]; {1st Px3PKey is always empty string }
         if Px3PKey <> '' then begin
           MyPx3PProtect(pChar(Px3PKey));
           MyPx3PProtectCalled := True;
         end;
         if CheckSumToTest = CalcPswCheckSum(edit1.text) then begin
           Found := True;
           Px3PKeyFound := Px3PKey;
           break;
         end;
       end;
     finally
       if MyPx3PProtectCalled then MyPx3PProtect('');
     end;
     if not Found then begin
       canclose := false;
       messagedlg(LoadStr(msg_WrongPassword),mtWarning,[mbOK],0);;
     end;
{$ELSE}
     if {verify password} CheckSumToTest <> CalcPswCheckSum(edit1.text) then begin
       canclose := false;
       messagedlg(LoadStr(msg_WrongPassword),mtWarning,[mbOK],0);;
     end;
{$ENDIF}
   end;
 end;
end;

procedure TFormPswd.FormCreate(Sender: TObject);
begin
  SetTexts;
end;


end.
